# $Id: esr_item.rb,v 1.3 2006/10/21 07:47:38 nisyu Exp $

def esr_item_init_pre
  @esr_item = EsrItem.new( (Request.form['edit_id'] || Request['edit_id'] || 0).to_i )
end

def esr_item_edit
  esr_item_init_pre unless @esr_item
	return nil unless Request['edit_id']
	
	if Request["c"] == 'itemedit' and Request["ce"] == 'ext'
		@esr_item[:item_name]       = Request["item_name"]
		@esr_item[:item_code]       = Request["item_code"]
		@esr_item.set_inventory(Request["r_inventory"].to_i - @esr_item.get_inventory(true), true)
		@esr_item[:cost]            = Request["cost"].to_i
		@esr_item[:price]           = Request["price"].to_i
		@esr_item[:normal_price]    = Request["normal_price"].to_i
		@esr_item[:pretax]          = Request["pretax"].to_i
		@esr_item[:disp_start_date] = DateTime.parse_or(Request["disp_start_date"])
		@esr_item[:disp_end_date]   = DateTime.parse_or(Request["disp_end_date"],"9999-01-01 00:00:00")
		@esr_item[:disp_flg]        = Request["disp_flg"]
		@esr_item.commit
	end
	ms = nil
	if @esr_item.mate_list
	  mt = []
	  @esr_item.mate_list.each{|m|
      mt << {
        :name => a(:href => "mate.htm?c=mateedit&edit_id=#{m[:material_id]}"){ m[:material_name] },
        :id => "%06d" % m[:material_id],
        :inv => {:r => m.get_inventory(true),:v => m.get_inventory},
        :qt => m.base_qt,
        :org => m[:inventory] }
	  }
	  ms = {:mates => mt }
	end
	
  {
    :p => [
        a(:name => 'c',:value => 'itemedit'),
        a(:name => 'ce',:value => 'ext'),
        a(:name => 'edit_id',:value => @esr_item[:item_id]),
      ],
    :item_id => @esr_item[:item_id],
    :item_name => a(:name => "item_name", :value => @esr_item[:item_name]) ,
    :item_code => a(:name => "item_code", :value => @esr_item[:item_code]) ,
    :r_inventory => ms ? nil : a(:name => "r_inventory", :value => @esr_item.get_inventory(true) ) ,
    :r_inventory_v => ms ? @esr_item.get_inventory(true) : nil,
    :inventory => @esr_item.get_inventory,
    :cost => ms ? nil : a(:name => "cost", :value => @esr_item.get_cost) ,
    :cost_v => ms ? @esr_item.get_cost : nil ,
    :price => a(:name => "price", :value => @esr_item[:price]) ,
    :normal_price => a(:name => "normal_price", :value => @esr_item[:normal_price]) ,
    :pretax => a(:name => "pretax"){ {:pretax_s => form_select([
      {'0' => ''},{'1' => 'ǹ'} ], @esr_item[:pretax].to_s )} },
    :disp_start_date => a(:name => "disp_start_date", :value => @esr_item[:disp_start_date].to_sql ) ,
    :disp_end_date => a(:name => "disp_end_date", :value => @esr_item[:disp_end_date].to_sql ) ,
    :disp_flg => a(:name => "disp_flg"){ {:disp_flg_s => form_select([
      {'n' => '/'},{'p' => 'ɽ'},{'h' => 'ɽ'},{'d' => ''} ],  @esr_item[:disp_flg] )} },
    :mate_list => ms,
    :edit_mate_list_link => a(:href => "item_mate_list.htm?c=item_mlist_edit&edit_id=#{@esr_item[:item_id]}"){{}},
    :plist => esr_item_plist
  }
end

def esr_item_mate_list_edit
  esr_item_init_pre unless @esr_item
	return nil unless Request['edit_id']
	esr_item_mate_list_pre unless @esr_item_list
	
	if Request.form["c"] == 'item_mlist_edit' and Request.form["ce"] == 'ext'
    @esr_item.clear_mate
    Request.form.each{|k,v|
      if /^add\_mate\_(\d+)$/ =~ k
        @esr_item.add_mate($1.to_i, (Request["add_mate_ct_#{$1}"] || 1).to_i ) if v.to_s == 'on'
      end
    }
	end
	ms1 = nil
	if @esr_item.mate_list
	  ms1 = []
    @esr_item.mate_list.each{|m|
      mi = "%06d" % m[:material_id]
	    ms1 << {
        :id => mi,
        :name => a(:href => "mate.htm?edit_id=#{m[:material_id]}&c=mateedit"){ m[:material_name] },
        :inv => {:v => m.get_inventory, :r => m.get_inventory(true)},
        :add_mate => a(:name =>"add_mate_#{mi}",:checked => "checked"),
        :add_mate_ct => a(:name =>"add_mate_ct_#{mi}",:value => m.base_qt)
      }
    }
  end
  {
    :item_name => @esr_item[:item_name],
    :p => [
        a(:name => 'c',:value => 'item_mlist_edit'),
        a(:name => 'ce',:value => 'ext'),
        a(:name => 'edit_id',:value => @esr_item[:item_id]),
      ],
    :mate_list => { :mates => ms1 },
    :list_navi => esr_item_edit_list_navi_in("item_mate_list.htm",{:c => "item_mlist_edit",:edit_id => @esr_item[:item_id]}),
    :rec => @esr_item_list }
end

def esr_item_mate_list_pre
	pagen = EsrMaterial.new(0)
	@esr_item_list = []
	rec,info = pagen.get_list(Request["page"] || 1,Request["pagect"] || 50)
	@esr_item_maxpage = info[:max_page]
	pa = (!Request["page"] || Request["page"] == '') ? '1' : Request["page"]
	q = { :c => 'mateedit',:page => pa }
	rec.each{|rs|
	  q[:edit_id] = rs[:material_id]
		@esr_item_list << {
      :id => "%06d" % rs[:material_id],
      :name => a(:href => "mate.htm?" + q.to_urlq){rs[:material_name]},
      :inv => {:v => rs[:inventory], :r => rs[:r_inventory]},
      :add_mate => a(:name =>"add_mate_#{rs[:material_id]}",:checked => nil),
      :add_mate_ct => a(:name =>"add_mate_ct_#{rs[:material_id]}",:value => 1) }
	}
end

def esr_item_newlink
	a(:href => "?edit_id=0&c=itemedit"){{}}
end

def esr_item_listlink
  q = {:page => Request["page"] || 1,
    :pagect => Request["pagect"] || 50 }
	a(:href => "?" + q.to_urlq ){{}}
end

def esr_item_edit_list
  esr_item_init_pre unless @esr_item
	return nil if Request['edit_id']
	esr_item_list_pre unless @esr_item_list
	
  {
    :list_navi => esr_item_edit_list_navi,
    :rec => @esr_item_list
  }
end

def esr_item_edit_list_navi
  esr_item_edit_list_navi_in("item.htm")
end

def esr_item_edit_list_navi_in(tname,q=nil,il=nil)
	esr_item_list_pre unless @esr_item_list
	page_navi(@esr_item_maxpage,"page",{"pagect" => 50,:script_name => tname,:add_query => q})
end

def esr_item_list_pre
	pagen = EsrItem.new(0)
	@esr_item_list = []
	rec,info = pagen.get_list(Request["page"] || 1,Request["pagect"] || 50)
	@esr_item_maxpage = info[:max_page]
	pa = (!Request["page"] || Request["page"] == '') ? '1' : Request["page"]
	q = { :c => 'itemedit',:page => pa }
	rec.each{|rs|
	  q[:edit_id] = rs[:item_id]
		@esr_item_list << {
      :item_id =>  "%06d" % rs[:item_id],
      :item_name => a(:href => "item.htm?" + q.to_urlq){rs[:item_name]} ,
      :cost => rs[:cost].to_money,
      :price => rs[:price].to_money,
      :inventory => rs[:inventory],
      :disp_span => rs[:disp_start_date].to_sql + '' + rs[:disp_end_date].to_sql,
      :flags => {:flag => rs[:disp_flg]} }
	}
end

def esr_item_plist
  ret = []
  @esr_item.get_plist.each{|i|
    ret << {:id => "%06d" % i[:product_id], :name => a(:href =>  "product.htm?p=#{i[:product_id]}"){i[:product_name]}} }
  ret
end
