# $Id: esr_prod.rb,v 1.3 2006/11/01 08:39:59 nisyu Exp $

def esr_pg_edit
	return nil unless @pagen
	if @pg_pms[1]
		if Request["esr_pg_edit"] == "on"
			@pagen[:product_name]    = Request["in_esr_pg_title"]
			@pagen[:content]         = Request["in_esr_pg_text"]
			@pagen[:template]        = Request["in_esr_pg_template"]
			@pagen[:disp_start_date] = DateTime.parse_or(Request["in_esr_start_date"])
			@pagen[:disp_end_date]   = DateTime.parse_or(Request["in_esr_end_date"],"9999-01-01 00:00:00")
			@pagen[:user_id]         = Request["in_esr_user_id"]
			@pagen[:group_id]        = Request["in_esr_group_id"]
			@pagen[:permission]      = Request["in_esr_permission"].to_i(8)
			@pagen.clear_cate
			Request["in_esr_cate_select",nil].each{|c|
			  @pagen.add_cate(c.to_i) }
			@pagen.commit
		end
	end
	ms = nil
	ca = nil
	tlist = @pagen.get_item_list
	if tlist && tlist.size >= 1
	  mt = []
	  tlist.each{|m|
      mt << {
        :name => a(:href => "item.htm?c=itemedit&edit_id=#{m[:item_id]}"){ m[:item_name] },
        :id => "%06d" % m[:item_id],
        :inv => {:r => m.get_inventory(true),:v => m.get_inventory} }
    }
    ms = {:items => mt }
	end
	ca_a = BosCategory.new(0).cate_list('c',{:category_id => 0,:category_name => ""},0)
	ca_s = @pagen.get_cate_list
	if ca_a
	  cat = []
	  selects = []
	  ca_a.each{|c|
      cat << {c[:category_id].to_s => c[:category_name]}
	    ca_s.each{|cc|
	      selects << c[:category_id].to_s if c[:category_id] == cc[:category_id] }
	  }
	  ca = a(:name => "in_esr_cate_select"){{:cates => form_select(cat,selects) }}
	end
	{
		:esr_pg_id         => @pagen[:product_id],
		:p                 => a(:value => @pagen[:product_id]),
		:in_esr_pg_id      => a(:value => @pagen[:product_id]),
		:in_esr_pg_title   => a(:value => @pagen[:product_name]),
		:in_esr_pg_text    => @pagen[:content],
		:in_esr_template   => a(:value => @pagen[:template]),
		:in_esr_start_date => a(:value => (@pagen[:disp_start_date] ? @pagen[:disp_start_date].to_sql : "1900-01-01 00:00:00")),
		:in_esr_end_date   => a(:value => (@pagen[:disp_end_date]   ? @pagen[:disp_end_date].to_sql   : "9999-01-01 00:00:00")),
		:in_esr_user_id    => a(:value => ((!@pagen[:user_id] || @pagen[:user_id] == "") ? @login_user[:user_id] : @pagen[:user_id] )),
		:in_esr_group_id   => {:groups => form_select(
				BosGroup.get_all_group_list.collect{|a| { a[:group_id].to_s => a[:group_name] } },@pagen[:group_id])},
		:in_esr_permission => a(:value => (@pagen[:permission]      ? @pagen[:permission].to_s(8)     : "750" )),
    :item_list => ms,
    :cate_list => ca,
    :edit_item_list_link => a(:href => "prod_item_list.htm?p=#{@pagen[:product_id]}"){{}}
	}
end

def esr_pg_editlink
	ret = nil
	if bos_user_admin_only_dev
		ret = a(:href => "admin/esr/product.htm?p=#{@pagen[:product_id]}"){"Խ"} if @pagen && @pagen[:product_id]
	end
	ret
end

def esr_pg_viewlink
	return nil unless @pagen
	a(:href => "../../esr-prod.htm?p=#{@pagen[:product_id]}"){{}}
end

def esr_pg_newlink
	a(:href => "?p=0"){{}}
end

def esr_pg_listlink
  q = {:page => Request["page"] || 1,
    :pagect => Request["pagect"] || 50 }
	a(:href => "?" + q.to_urlq ){{}}
end

def esr_pg_list_navi
	esr_pg_list_pre unless @esr_pg_list
	page_navi(@esr_pg_maxpage,"page",{"pagect" => 50,:script_name => "product.htm"})
end

def esr_pg_list
  return nil if @pagen
	esr_pg_list_pre unless @esr_pg_list
	{ :list_navi => esr_pg_list_navi,
	  :rec => @esr_pg_list }
end

def esr_pg_list_pre
	pagen = EsrProduct.new(0)
	@esr_pg_list = []
	rec,info = pagen.get_list(Request["page"] || 1,Request["pagect"] || 50)
	@esr_pg_maxpage = info[:max_page]
	pa = (!Request["page"] || Request["page"] == '') ? '1' : Request["page"]
	rec.each{|rs|
		@esr_pg_list << {
			:no    => rs[:product_id],
			:title => rs[:product_name],
			:view  => a(:href => "../../esr-prod.htm?p=#{rs[:product_id]}"){{}},
			:edit  => a(:href => "product.htm?p=#{rs[:product_id]}&page=#{pa}"){{}}} }
end

def esr_imageset_1
  esr_imageset(1)
end
alias :esr_imageset_f :esr_imageset_1

def esr_imageset_2
  esr_imageset(2)
end

def esr_imageset_3
  esr_imageset(3)
end

def esr_imageset_4
  esr_imageset(4)
end

def esr_imageset_5
  esr_imageset(5)
end

def esr_imageset(disp_order)
  return nil unless @pagen
	return nil unless bos_chk_v
	im = @pagen.image(disp_order)
	ret = nil
	if im
    ret = { :big_a => a(:href => im[1]){
        { :s => a(:src => im[0]) } } }
	end
	ret
end

def esr_prod_item_list_edit
  return nil unless @pagen
	esr_prod_item_list_pre unless @esr_item_list
	
	if Request.form["c"] == 'prod_ilist_edit' and Request.form["ce"] == 'ext'
    @pagen.clear_item
    Request.form.each{|k,v|
      if /^add\_item\_(\d+)$/ =~ k
        @pagen.add_item($1.to_i, (Request["add_item_order_#{$1}"] || 0).to_i ) if v.to_s == 'on'
      end
    }
	end
	ms1 = nil
	tls = @pagen.get_item_list true
	if tls
	  ms1 = []
    tls.each{|m|
	    tli = EsrItem.new(m[:sub_item_id])
      mi = "%06d" % tli[:item_id]
	    ms1 << {
        :id => mi,
        :name => a(:href => "item.htm?edit_id=#{tli[:item_id]}&c=itemedit"){ tli[:item_name] },
        :price => tli[:price],
        :inv => {:v => tli.get_inventory, :r => tli.get_inventory(true)},
        :add_item => a(:name =>"add_item_#{mi}",:checked => "checked"),
        :add_item_order => a(:name =>"add_item_order_#{mi}",:value => m[:disp_order])
      }
    }
  end
  {
    :product_id => @pagen[:product_id],
    :p => [
        a(:name => 'c',:value => 'prod_ilist_edit'),
        a(:name => 'ce',:value => 'ext'),
        a(:name => 'p',:value => @pagen[:product_id]),
      ],
    :item_list => { :items => ms1 },
    :list_navi => esr_item_edit_list_navi_in("prod_item_list.htm",{:p => @pagen[:product_id]}),
    :rec => @esr_item_list }
end

def esr_prod_item_list_pre
	pagen = EsrItem.new(0)
	@esr_item_list = []
	rec,info = pagen.get_list(Request["page"] || 1,Request["pagect"] || 50)
	@esr_item_maxpage = info[:max_page]
	pa = (!Request["page"] || Request["page"] == '') ? '1' : Request["page"]
	q = { :c => 'itemedit',:page => pa }
	rec.each{|rs|
	  q[:edit_id] = rs[:item_id]
    mi = "%06d" % rs[:item_id]
		@esr_item_list << {
      :id => mi,
      :name => a(:href => "item.htm?" + q.to_urlq){rs[:item_name]},
      :price => rs[:price],
      :inv => {:v => rs[:inventory], :r => rs[:r_inventory]},
      :add_item => a(:name =>"add_item_#{mi}",:checked => nil),
      :add_item_order => a(:name =>"add_item_order_#{mi}",:value => 0) }
	}
end

