# $Id: esr_tbedit.rb,v 1.1 2006/10/18 05:57:44 nisyu Exp $

class EsrTableEdit
	include BOS::PropMethods
	attr_reader :id
	
	def initialize(tablebasename)
    @mydb = BOS::MySQLo
    @mydo = BOS::Rdb
    @prop = {
      :table_basename => tablebasename,
      :table_name => "bos_%s_esr_%s" % [BOS::Prop[:site_name],tablebasename],
      :q => {
#        :c => 'tbedit',
        :tbl => tablebasename },
    }
    @prop[:data] = set_default
	end
	
	def load_id(pid=nil)
	  pid ||= @prop[:id]
		return nil unless pid
		@prop[:data] = @mydo.exp({
			:command => "s",
			:target  => @prop[:table_name],
			:cols    => set_default,
			:where   => w(@id.to_s){|a| a == pid } })[0]
		@prop[:data]
	end
	
	def get_list(pg=1, pc=10, sc="")
		pg ||= 1
		pc ||= 10
		@mydo.exp({
			:command => "s",
			:target  => @prop[:table_name],
			:cols    => set_default,
			:order   => "#{@id} ASC",
			:page    => pg,
			:pagesize => pc })
	end
	
	def set_default
    table_attr = MySQLo.list_fields_bos(@prop[:table_name])
    ret = {}
    table_attr.each{|rk| rk.each{|tk,tv|
      v = 0
      case tv
      when 'date','datetime','time','text','char'
        v = ''
      when 'id'
        @id = tk.intern
      end
      ret[tk.intern] = v
    } }
    ret
	end
	
	def commit
		if @prop[:data][@id] == 0 then
			@prop[:data].delete(@id)
			@prop[:data][@id] = @mydo.exp({
				:command => "i",
				:target  => @prop[:table_name],
				:cols    => @prop[:data] })[:insid]
		else
		  lct = @mydo.exp({
				:command => "u",
				:target  => @prop[:table_name],
				:cols    => @prop[:data],
				:where   => "#{@id} = #{@prop[:data][@id]}" })
		end

		@prop[:data][@id]
	end

end
