# $Id: esr_order.rb,v 1.4 2006/10/24 08:27:13 nisyu Exp $

#def pre_esr_order
#  @esr_order = EsrOrder.new(Session.session_id) unless @esr_order
#  @esr_order_tg = EsrOrder.new(Session.session_id,(Request.form["oid"] || Request["oid"]).to_i) if (Request.form["oid"] || Request["oid"])
#end

def esr_order_cart_pre
  @esr_order = EsrOrder.new(Session.session_id) unless @esr_order
  @esr_order_tg = EsrOrder.new(Session.session_id,(Request.form["oid"] || Request["oid"]).to_i) if (Request.form["oid"] || Request["oid"])
  
  if Request.form['esr_cart_add_item_id'] && Request.form['esr_cart_add_qt']
    @esr_order.add_item(Request.form['esr_cart_add_item_id'].to_i,Request.form['esr_cart_add_qt'].to_i)
  end
  if Request.form['esr_cart_submit']
    @esr_order.clear_cart if Request.form['esr_cart_submit'] == "ꥢ"
  end
end

def esr_cart_table
  esr_order_cart_pre unless @esr_order
  return nil unless @esr_order
  
  il = @esr_order.order_item_list
  return nil if il.size == 0
  rec = []
  il.each{|it|
    rec << { :item_name => it[:item_name],
      :item_id => "%06d" % it[:item_id],
      :price => it[:price].to_money(true),
      :qt => it[:quantity],
      :tprice => it[:total].to_money(true) } }
  {
    :rec => rec,
    :ex_rec => nil,
    # [{ :item_name => "ʤ", :tprice => 200 } ],
    :t_rec => [
        { :item_name => "", :tprice => @esr_order[:total].to_money(true) } ]
  }
end

def esr_order_confirm
  esr_order_cart_pre unless @esr_order
  return "error" unless @esr_order
  @esr_order[:registrant] = @login_user[:user_id]
  @order_error = @esr_order.confirm(esr_order_code_ex)
end

def esr_order_code_ex
  esr_order_cart_pre unless @esr_order
  "%06d" % @esr_order[:order_id]
#  DateTime.now.to_sql.tr('- :','') + '-' + ("%06d" % @esr_order[:order_id])
end

def esr_order_error
  esr_order_cart_pre unless @esr_order
  @order_error
end

def esr_order_list
  esr_order_cart_pre unless @esr_order
  return nil if @esr_order_tg
  esr_order_list_pre unless @esr_item_list
  
  {
    :list_navi => esr_item_edit_list_navi_in("order.htm"),
    :rec => @esr_item_list
  }
end

def esr_order_list_pre
	pagen = EsrOrder.new(0)
	@esr_item_list = []
	rec,info = pagen.get_list(Request["page"] || 1,Request["pagect"] || 50)
	@esr_item_maxpage = info[:max_page]
	pa = (!Request["page"] || Request["page"] == '') ? '1' : Request["page"]
	q = { :c => 'orderdetail',:page => pa }
	rec.each{|rs|
	  q[:oid] = rs[:order_id]
	  dt = EsrOrder.new(Session.session_id,rs[:order_id])
		@esr_item_list << {
      :order_id => a(:href =>"order.htm?" + q.to_urlq){rs[:order_code]},
      :user_name_box => {
#        :user_name => dt.delivery_address[:postalcode],
        :user_ids => {:user_id => a(:href => ""){dt[:registrant]} }
      },
      :order_date => dt[:order_flg].to_sql,
      :pay_method => dt[:payment_method],
      :flags => { :flag => ["-"] }
    }
	}
end

def esr_order_details
  esr_order_cart_pre unless @esr_order
  return nil unless @esr_order_tg
  o = @esr_order_tg
  
  il = o.order_item_list
  rec = nil
  if il.size > 0
    rec = []
    il.each{|it|
      rec << { :item_name => it[:item_name],
        :item_id => "%06d" % it[:item_id],
        :price => it[:price].to_money(true),
        :qt => it[:quantity],
        :tprice => it[:total].to_money(true) } }
  end
  
  {
    :p => [{:name => "name",:value => "val"}],
    :order_id => o[:order_code],
    :order_date => o[:order_flg] ? o[:order_flg].to_sql : nil ,
    :o_address => nil,
    :s_address => nil,
#    :o_address => {:postal_code => o.delivery_address[:postalcode],
#      :address => o.delivery_address[:postalcode],
#      :name => o.delivery_address[:postalcode] + ' ' + o.delivery_address[:postalcoode]},
#    :s_address => {:postal_code => o.user_address[:postalcode],
#      :address => o.user_address[:postalcode],
#      :name => o.user_address[:postalcode] + ' ' + o.user_address[:postalcode]},
    :rec => rec,
#    :ex_rec => [
#        { :item_name => "ʤ", :tprice => 200 } ],
    :t_rec => [
        { :item_name => "", :tprice => o[:total].to_money(true) } ]
  }
end

