# $Id: esr_tbedit.rb,v 1.1 2006/10/18 05:57:44 nisyu Exp $

def pre_esr_tbedit
  return nil unless Request['tbl']
  tmpt = Request['tbl']
  @tbedit = EsrTableEdit.new(tmpt)
  if Request["c"] == 'tbedit'
    @tbedit[:id] = (Request['edit_id'] || 0).to_i
    
    if Request["ce"] == 'ext'
      @tbedit.load_id
      @tbedit[:data].each{|k,v|
        next if k == @tbedit.id
        kk = Request[k.to_s]
        if kk then
          if v.is_a? Numeric
            @tbedit[:data][k] = kk.to_i
          else
            @tbedit[:data][k] = kk.to_s
          end
        end
      }
      @tbedit.commit
    end
  end
end

def esr_tbedit_table_name
  return nil unless @tbedit
  @tbedit[:table_basename]
end

def esr_tbedit_toplink
  return nil unless @tbedit
	a(:href => "tedit.htm?tbl=#{@tbedit[:table_basename]}"){{}}
end

def esr_tbedit_list_navi
  return nil unless @tbedit
	esr_tbedit_list_pre unless @tbedit_list
	page_navi(@tbedit_maxpage,"page",{
	  "pagect" => 20,
	  :add_query => @tbedit[:q],
    :script_name => '',
    :size => 20})
end

def esr_tbedit_list
  return nil unless @tbedit
	n = esr_tbedit_list_pre unless @tbedit_list
  @tbedit_list[:list_navi] = esr_tbedit_list_navi if n
  @tbedit_list
end

def esr_tbedit_list_pre
  return nil unless @tbedit
  if Request["c"] != 'tbedit'
    q = @tbedit[:q].dup
    q[:c] = 'tbedit'
    q[:pagect] = (Request["pagect"] || 20).to_i
    q[:page] = (Request["page"] || 1).to_i
    table_attr = MySQLo.list_fields_bos(@tbedit[:table_name])
    hrec = []
    table_attr.each{|rk| rk.each{|tk,tv| hrec << tk } }
    tit_rec = {:data => hrec}
    
    rrec = []
    rec,info = @tbedit.get_list(q[:page], q[:pagect])
    rec.each{|re|
      r = []
      hrec.each{|b| r << re[b.intern] }
      q[:edit_id] = re[:item_id] # dummy
      rrec << {:data => r, :edit => a(:href => "?" + q.to_urlq){"Խ"} }
    }
    @tbedit_maxpage = info[:max_page]
#    @tbedit_list = { :list_navi => esr_tbedit_list_navi, :tit_rec => tit_rec, :rec => rrec }
    @tbedit_list = { :list_navi => nil, :tit_rec => tit_rec, :rec => rrec }
  else
    @tbedit_list = nil
  end
end

def esr_tbedit_edit
  return nil unless @tbedit
  table_attr = MySQLo.list_fields_bos(@tbedit[:table_name])
  if Request["c"] == 'tbedit'
    ret = {
      :p => [
          a(:name => 'tbl',:value => @tbedit[:table_basename]),
          a(:name => 'c',:value => 'tbedit'),
          a(:name => 'ce',:value => 'ext'),
          a(:name => 'edit_id',:value => @tbedit[:id] )
        ],
      :rec => []
    }
    dat = @tbedit.load_id
    table_attr.each{|rv|
      k,v = '',''
      rv.each{|tk,tv| k,v = tk,tv }
      td = dat[k.intern]
      
      h = Hash.new(nil)
      case v
      when 'numeric','date','datetime','time','char'
        ht = {:cname => k,:val => a(:value => td,:name => k){{}} }
      when 'text'
        ht = {:cname => k,:val => a(:name => k){td} }
      when 'id'
        ht = {:cname => k,:valv => td }
      end
      h[v.intern] = ht
      
      ret[:rec] << h
    }
    ret
  else
    nil
  end
end
